# td1.py -- AP3 TD1 solutions
#
# This file contains the solutions for the questions 11 to 16 in TD1
# of the course AP3 2016-2017

## question 11
# --
# maximum(n,m) returns the maximum of n and m
# n and m should be integers
def maximum(n,m):
  return n if n>m else m

## question 12
# --
# for this question it might be useful to use multiple functions

# minimum(n,m) returns the maximum of n and m
# n and m should be integers
def minimum(n,m):
  return n if n<m else m

# middle(n,m,p) returns the middle element if n, m and p are pairwise
# distincts, else it returns the top most element
def middle(n,m,p):
  
  def middle_sortedlist(l): # l should have lentgh 3
    return l[2] if l[0] == l[1] else l[1]
  
  l = [minimum(m,n),maximum(m,n)]
  if p < l[0]: l = [p]+l
  elif p > l[1]: l = l+[p]
  else: l = [l[0],p,l[1]]
  return middle_sortedlist(l)

## question 13
# --
# mult_table(n,start,stop) prints out the multiplication table of n
# from start*n to stop*n (included).
# n, start and stop should be integers.
def mult_table(n,start=1,stop=10):
  for i in range(start,stop+1):
    print str(i) + "*" + str(n) + "=" + str(i*n)
    print "\n"
  return None

## question 14
# --
# print_inf(l,bound) prints out the elements of l that are less or
# equal to bound.
# l should be a list of integers, bound should be an integer.
def print_int(l,bound):
  for x in l:
    if x<=bound: print x
  return None

## question 15
# ---
def add_int(n,m): return n+m

def add_int_list(l,start,stop):
  try:
    assert start<len(l) and stop<len(l)
    res=0
    for x in l[start:stop+1]: res=add_int(res,x)
    return res
  except TypeError:
    print "add_int_list adds the elements of a list of *integers*"
  except AssertionError:
    print "starting and stopping index should be *less* than the lenght of the list"
  except:
    print "unexpected error..."
  return None

## question 16
# ---
def print_even_and_odd(n):
  even = "Even numbers: "
  for i in range(1,n): even = even + (str(2*i) + ", ")
  odd = "Odd numbers: "
  while i>0:
    odd = odd + (str(2*i-1) + ", ")
    i -= 1
  print even
  print odd
  return None
